function dmat = compute_spatial_dist_ver2(A1,A2,lambda,style)

if strcmp(style,'rect')
    ord = lambda;
elseif strcmp(style,'exp')
    ord = length(A1);
else
    error
end

xx = 1:length(A1);

max_inds1 = NaN*zeros(1,ord);
max_inds2 = NaN*zeros(1,ord);
An1 = A1;
An2 = A2;
for n = 1:ord
    M = An1';
    [ma,mai] = max(M);
    An1(mai) = NaN;
    max_inds1(n) = mai;
    M = An2';
    [ma,mai] = max(M);
    An2(mai) = NaN;
    max_inds2(n) = mai;
end

An1(~isnan(An1)) = 0;
An1(isnan(An1)) = 1;
An2(~isnan(An2)) = 0;
An2(isnan(An2)) = 1;

D = load('NM306coildef');
dmat = 0;
for r = 1:ord
    val = norm( D.VM(max_inds1(r)) - D.VM(max_inds2(r)) );
    if strcmp(style,'rect') % rectangular decay function
        C = 1;
    else % exponential decay function
        C = exp(-lambda*(xx(r)-1));
    end
    dmat = dmat + C*val;
end

