function [DataCV,BL] = divide_data_into_blocks(data,labels,nr_blocks,style,saveMem,BL)

if nargin < 4
    style = 'linear';
    saveMem = 0;
    BL = [];
end
if nargin < 5
    BL = [];
    saveMem = 0;
end
if nargin < 6
    BL = [];
end


if isempty(BL)
    % if CV block indices not provided by a user, create a random CV partition
    L = length(labels);
    c = cvpartition(L,'KFold',nr_blocks);
    block_end = cumsum(c.TestSize);
    block_start = [1 block_end(1:end)+1];
    clear BL
    for s = 1:length(block_end)
        BL{s} = block_start(s):block_end(s);
    end
end

Le = 1:length(labels);

clear DataCV
for s = 1:length(BL)
    inds_train = setdiff(Le,BL{s});
    inds_test = BL{s};
    switch style
        case 'threewayDA'
            for m = 1:length(data)
                if saveMem            
                    DataCV.data{s,m,1} = inds_train;
                    DataCV.data{s,m,2} = inds_test;            
                else
                    DataCV.data{s,m,1} = data{m}(:,:,inds_train);
                    DataCV.data{s,m,2} = data{m}(:,:,inds_test);                                
                end
            end            
        case 'bilinear'
            DataCV.data{s,1} = data(inds_train,:,:);
            DataCV.data{s,2} = data(inds_test,:,:);
        case 'linear'
            DataCV.data{s,1} = data(inds_train,:);
            DataCV.data{s,2} = data(inds_test,:);
        otherwise
            error('STYLE must be ''linear'' or ''bilinear'' or ''threewayDA''!')
    end
    DataCV.labels{s,1} = labels(inds_train);
    DataCV.labels{s,2} = labels(inds_test);
end
