
dimTH = 1;

if strcmp(style,'temporalbilinear') | strcmp(style,'bilinear')
    lambdas_comp = [0 0.1 0.5 2.^(0:8)];
    %    lambdas_comp = [0];
    lambdas_freq = [0 0.5 1]; % regularization of frequency coefficients
    LimMax = sqrt(size(data,3));
    %    modelRank = 1;
    lambdas_comp(lambdas_comp>LimMax) = [];
    disp(['Number of lambdas for bilinear model = ' num2str(length(lambdas_comp)*length(lambdas_freq))])
    disp(['Rank = ' num2str(modelRank)])
    nLambda = length(lambdas_comp);
else
    nLambda = 10;
end

boxC = 10.^(linspace(-5,5,11)); % SVM hyperparameter sequence
gammas = linspace(0.1,1,10); % LDA hyperparameter sequence
deltas = 10.^(linspace(-6,3,10));
logLambdas = logspace(-6,-0.5,11);
gammas_deltas = zeros(length(gammas)*length(deltas),2)*NaN;
%'GradientTolerance',1e-8

it = 1;
for s1 = 1:length(gammas)
    for s2 = 1:length(deltas)
        gammas_deltas(it,:) = [gammas(s1) deltas(s2)];
        it = it + 1;
    end
end

if size(data,2) > dimTH
    highDim = 1;
    boxC = logLambdas; % in high-dim case, use lambdas instead of box constraints in the SVM training.
    %gammas = linspace(0.6,1,3); % LDA hyperparameter sequence
    %deltas = 10.^(-6:2:5);
    %gammas_deltas = zeros(length(gammas)*length(deltas),2)*NaN;    
%    disp(['Dimension greater than ' num2str(dimTH) ', switching to high-dimensional classification mode...'])
else
    highDim = 0;
end

stability = 0;
save_res = 0;
verbose_on = 0;
stand = 0; % svm standardization on/off

nrICs = modelRank;

%lambdas_freq = [0 5 10]; % regularization of frequency coefficients

nFolds = 10; % outer CV loop
nFoldsTrain = 10; % inner CV loop
plotFigs = 0;
normalize = 1;
saveMem = 1;

%[nFolds,nFoldsTrain,plotFigs,normalize,saveMem,labels,nrClasses,subj_index,LOSO]

if size(labels,1) == 2 % perform leave-one-subject-out analysis
    subj_index = labels(2,:);
    labels = labels(1,:);
    LOSO = 1;
else
    subj_index = [];
    LOSO = 0;
end


% parse inputs:
un = unique(labels);
nrClasses = length(un);
if ~isnumeric(labels)
    error('Class labels must be given as a vector of numbers!')
end

if nrClasses == 2
    if min(un) == 0 && max(un) == 1
        labels = logical(labels);
    elseif min(un) == 1 && max(un) == 2
        labels = logical(labels - 1);
    else
        error('Class labels must be given as {0,1} or {1,2}')
    end
end
if ~isempty(shuffleId)
    if shuffleId < 0 || ~isnumeric(shuffleId) || length(shuffleId) ~= 1
        error('Shuffle Id must be a whole number!')
    end
end
%if ~ischar(dataSetName)
%    error('dataSetName must be a string!')
%end
labels = labels(:);
