function [data_tr,labels_tr,data_te,labels_te,UU,VV] = pick_innerfold_data(DataCVTrain,style,saveMem,datO,nn,nrICs,modelRank)

UU = [];
VV = [];

switch style
    case 'normal'
        data_tr = DataCVTrain.data{nn,1};
        labels_tr = DataCVTrain.labels{nn,1};
        labels_te = DataCVTrain.labels{nn,2};
        data_te = DataCVTrain.data{nn,2};
    case {'bilinear','temporalbilinear'}
        clear data_tr
        for z = 1:size(DataCVTrain.data,2)
            if saveMem
                tr_inds = DataCVTrain.data{nn,z,1};
                data_tr{z} = datO{z}(:,:,tr_inds);
            else
                data_tr{z} = DataCVTrain.data{nn,z,1};
            end
        end
        labels_tr = DataCVTrain.labels{nn,1};
        clear data_te
        for z = 1:size(DataCVTrain.data,2)
            if saveMem
                te_inds = DataCVTrain.data{nn,z,2};
                data_te{z} = datO{z}(:,:,te_inds);
            else
                data_te{z} = DataCVTrain.data{nn,z,2};
            end
        end
        labels_te = DataCVTrain.labels{nn,2};
    case {'temporalthreewayDA','threewayDA','temporalthreewaySDA',...
            'temporalthreewayRDA','temporalthreewayDAfull','temporalthreewayDAfullorig'}
        clear data_tr
        for z = 1:size(DataCVTrain.data,2)
            if saveMem
                tr_inds = DataCVTrain.data{nn,z,1};
                data_tr{z} = datO{z}(:,:,tr_inds);
            else
                data_tr{z} = DataCVTrain.data{nn,z,1};
            end
        end
        labels_tr = DataCVTrain.labels{nn,1};
        clear data_te
        for z = 1:size(DataCVTrain.data,2)
            if saveMem
                te_inds = DataCVTrain.data{nn,z,2};
                data_te{z} = datO{z}(:,:,te_inds);
            else
                data_te{z} = DataCVTrain.data{nn,z,2};
            end
        end
        switch style
            case 'temporalthreewaySDA'
                Styl = 'sparse';
            case 'temporalthreewayRDA'
                Styl = 'diagonal';
            case 'temporalthreewayDAfull'
                Styl = 'full';
            case 'temporalthreewayDAfullorig'
                Styl = 'fullorig';
            otherwise
                Styl = 'normal';
        end        
        labels_te = DataCVTrain.labels{nn,2};
        [UU,VV] = estimate_TF_projections(data_tr,labels_tr,modelRank,Styl);
        data_tr = extract_TF_features(data_tr,UU,VV,Styl);
        data_te = extract_TF_features(data_te,UU,VV,Styl);
    case {'spectralLDA','temporalLDA','temporalRLDA','temporalLDAfull',...
            'spatiotemporalLDA','spatiotemporalRLDA',...
            'spatiotemporalLDAfull','spatialLDA','spatialRLDA','spatialLDAfull'}
        data_tr = DataCVTrain.data{nn,1};
        labels_tr = DataCVTrain.labels{nn,1};
        labels_te = DataCVTrain.labels{nn,2};
        data_te = DataCVTrain.data{nn,2};
        data_tr = permute(data_tr,[3 1 2]);
        data_te = permute(data_te,[3 1 2]);
        if strcmp(style,'spatiotemporalLDA') | strcmp(style,'spatiotemporalRLDA') | strcmp(style,'spatiotemporalLDAfull')
            Styl = style;
            dat_tmp = data_tr;clear data_tr;data_tr{1} = dat_tmp;
            [UU,VV] = estimate_TF_projections(data_tr,labels_tr,modelRank,Styl);
            data_tr = dat_tmp;
            data_tr = extract_TF_features(data_tr,UU,VV,Styl);
            data_te = extract_TF_features(data_te,UU,VV,Styl);
        else
            switch style 
                case {'temporalRLDA','spatialRLDA'}
                    regOpt = 'diag';                    
                case {'temporalLDAfull','spatialLDAfull'}
                    regOpt = 'none';                                        
                otherwise
                    regOpt = 'infinite';
            end
            [UU,VV] = estimate_projections(data_tr,labels_tr,'spectral_LDA',regOpt);
            data_tr = project_data(data_tr,[],VV,'spectral_LDA');
            data_te = project_data(data_te,[],VV,'spectral_LDA');
        end
    case {'spectralICA','temporalICA','temporalPCA'}
        switch style
            case 'spectralICA'
                sty = 'spectral_ICA';
            case 'temporalICA';
                sty = 'temporal_ICA';
            case 'temporalPCA';
                sty = 'temporal_PCA';
        end
        
        data_tr = DataCVTrain.data{nn,1};
        labels_tr = DataCVTrain.labels{nn,1};
        labels_te = DataCVTrain.labels{nn,2};
        data_te = DataCVTrain.data{nn,2};
        data_tr = permute(data_tr,[3 1 2]);
        data_te = permute(data_te,[3 1 2]);
        [UU,VV] = estimate_projections(data_tr,labels_tr,sty,nrICs);
        data_tr = project_data(data_tr,[],VV,sty);
        data_te = project_data(data_te,[],VV,sty);
end
