function [rows,cols] = plot_gradiometer_head(dat,accessorydata_dir,titles,LIM,threewayDAplot)

figure

if nargin < 5
    threewayDAplot = 0;
end

plot_lay = 0;


plotstyle = 'short';

if threewayDAplot
    plotstyle = 'long';    
end



if ~( strcmp(accessorydata_dir(end),'/') || strcmp(accessorydata_dir(end),'\') )
    accessorydata_dir = [accessorydata_dir '/'];
end    
load([accessorydata_dir 'gradiometerInfo.mat'])

if size(dat,2) ~= 204
   error('Gradiometer channel data for visualization must contain 204 columns!') 
end

if strcmp(plotstyle,'long')
    cols = 7;
else
   cols = 5; 
end
    
nPlots = size(dat,1);
rows = ceil(nPlots/cols);
if nPlots < cols
    rows = 1;
    cols = nPlots;
end

if threewayDAplot
    rows = rows + 1;
    nPlots = nPlots + cols;
    startPlot = cols + 1;
else     
    startPlot = 1;
end

ite = 1;
for m = startPlot:nPlots
    subplot(rows,cols,m)
    if size(LIM,1) > 1
        Li = LIM(ite,:);
    else
        Li = LIM; 
    end
    ft_plot_topo(chanX,chanY,dat(ite,:),opt{:},'clim',Li);
    if plot_lay
        ft_plot_lay(templay,'box','no','label',labelflg,'point','yes',...
            'pointsymbol',cfg.markersymbol,...
            'pointcolor',cfg.markercolor,...
            'pointsize',cfg.markersize,...
            'fontsize',cfg.markerfontsize,...
            'labeloffset',cfg.labeloffset)
        
    else
        
        axis auto
        axis equal
        axis off
    end
    if nargin == 2
       title(['interval ' num2str(ite)])
    else
       n = num2str( round(100*max(dat(ite,:)))/100 );
       if length(n) == 3
          n(end+1) = '0'; 
       end
%       H = title([{titles{m}};{['acc_{max}=' n]}]);
        H = title(titles{ite});

       H.FontSize = 9;
       H.FontWeight = 'normal';
    end
    ite = ite + 1;
end

