function badEEG = return_bad_eeg(subj_prefix,session)



%[sourceFilename,classNames,triggerChannels,delays,chanIndex,subj_prefix] = data_info(5,14)

%--- Give bad EEG channels: EEG = ch# 311-370 (EEG001-EEG60) ----
badEEG = {'EEG001' 'EEG035'}; % list EEG channels that won't be analyzed

%BEF
if strcmp(session, 'bef')
    if strcmp(subj_prefix, '3349_k01/')
        badEEG = {'EEG001' 'EEG002' 'EEG003' 'EEG035' 'EEG038' 'EEG043'};
    elseif strcmp(subj_prefix, '3350_k02/')
        badEEG = {'EEG001' 'EEG002' 'EEG004' 'EEG014' 'EEG015' 'EEG035' 'EEG023' 'EEG031' 'EEG034' 'EEG045' 'EEG049'};
    elseif strcmp(subj_prefix, '3351_k03/')
        badEEG = {'EEG001' 'EEG002' 'EEG004' 'EEG014' 'EEG015' 'EEG035' 'EEG023' 'EEG031' 'EEG034' 'EEG045' 'EEG049'};
    elseif strcmp(subj_prefix, '3353_k04/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG026' 'EEG045'};
    elseif strcmp(subj_prefix, '3354_k05/')
        badEEG = {'EEG001' 'EEG002' 'EEG004' 'EEG035' 'EEG015' 'EEG034' 'EEG035' 'EEG036' 'EEG038' 'EEG040' 'EEG045' 'EEG060'};
    elseif strcmp(subj_prefix, '3355_k06/')
        badEEG = {'EEG001' 'EEG002' 'EEG004' 'EEG035' 'EEG015' 'EEG036' 'EEG038' 'EEG040' 'EEG041' 'EEG044' 'EEG045'};
    elseif strcmp(subj_prefix, '3356_k07/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG027' 'EEG033' 'EEG054' 'EEG045'};
    elseif strcmp(subj_prefix, '3357_k08/')
        badEEG = {'EEG001' 'EEG002' 'EEG004' 'EEG035' 'EEG010' 'EEG011' 'EEG015' 'EEG026' 'EEG035' 'EEG041' 'EEG049' 'EEG056' 'EEG059'};
    elseif strcmp(subj_prefix, '3358_k09/')
        badEEG = {'EEG001' 'EEG002' 'EEG003' 'EEG004' 'EEG035' 'EEG015' 'EEG023' 'EEG026' 'EEG034' 'EEG044' 'EEG049' 'EEG060'};
    elseif strcmp(subj_prefix, '3359_k10/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG038' 'EEG045'};
    elseif strcmp(subj_prefix, '3360_k11/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG003' 'EEG006' 'EEG020' 'EEG045' 'EEG049'};
    elseif strcmp(subj_prefix, '3361_k12/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG020' 'EEG031' 'EEG045' 'EEG048' 'EEG049'};
    elseif strcmp(subj_prefix, '3362_k13/')
        badEEG = {'EEG001' 'EEG002' 'EEG003' 'EEG004' 'EEG035' 'EEG020' 'EEG026' 'EEG027' 'EEG038' 'EEG045' 'EEG040' 'EEG060'};
    elseif strcmp(subj_prefix, '3364_k14/')
        badEEG = {'EEG001' 'EEG002' 'EEG004' 'EEG035' 'EEG015' 'EEG036' 'EEG044' 'EEG045'};
    elseif strcmp(subj_prefix, '3366_k15/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG015' 'EEG020' 'EEG036' 'EEG045' 'EEG049' 'EEG054'};
    elseif strcmp(subj_prefix, '0000_k16/')
        badEEG = {'EEG001' 'EEG035'};
    end
end

%AFT
if strcmp(session,'aft')
    if strcmp(subj_prefix, '3349_k01/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG040' 'EEG038' 'EEG004'};
    elseif strcmp(subj_prefix, '3350_k02/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG003'};
    elseif strcmp(subj_prefix, '3351_k03/')
        badEEG = {'EEG001' 'EEG002' 'EEG035'};
    elseif strcmp(subj_prefix, '3353_k04/')
        badEEG = {'EEG001' 'EEG002' 'EEG004' 'EEG035' 'EEG038'};
    elseif strcmp(subj_prefix, '3354_k05/')
        badEEG = {'EEG001' 'EEG002' 'EEG004' 'EEG035' 'EEG038'};
    elseif strcmp(subj_prefix, '3355_k06/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG038' 'EEG004' 'EEG040'};
    elseif strcmp(subj_prefix, '3356_k07/')
        badEEG = {'EEG001' 'EEG002' 'EEG035'};
    elseif strcmp(subj_prefix, '3357_k08/')
        badEEG = {'EEG001' 'EEG002' 'EEG035'};
    elseif strcmp(subj_prefix, '3359_k10/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG003'};
    elseif strcmp(subj_prefix, '3360_k11/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG045'};
    elseif strcmp(subj_prefix, '3361_k12/')
        badEEG = {'EEG001' 'EEG002' 'EEG035' 'EEG045'};
    elseif strcmp(subj_prefix, '3362_k13/')
        badEEG = {'EEG001' 'EEG002' 'EEG035'};
    elseif strcmp(subj_prefix, '3366_k15/')
        badEEG = {'EEG001' 'EEG002' 'EEG035'};
    elseif strcmp(subj_prefix, '0000_k16/')
        badEEG = {'EEG001' 'EEG002' 'EEG003' 'EEG035'};
    end
end



