function epoch_dir = return_epoch_dir(task_selection,dataset,result_dir,epochingParams)

Fs = epochingParams.Fs;
winlen = epochingParams.winlen;
locut = epochingParams.locut;
highcut = epochingParams.highcut;
orde = epochingParams.orde;
nofiltering = epochingParams.nofiltering;
delay_corr = epochingParams.delay_corr;
stretch_corr = epochingParams.stretch_corr;


subject_result_dir = [result_dir 'task' num2str(task_selection) '/dataset' num2str(dataset) '/'];

if nofiltering
    epoch_dir = [subject_result_dir 'epochs' 'Fs' num2str(Fs) 'dcor' ...
        num2str(delay_corr) 'winlen' num2str(1000*winlen)];
else % add filtering params (Low-cut, High-cut, filter order)
    epoch_dir = [subject_result_dir 'epochs' 'Fs' num2str(Fs) ...
        'dcor' num2str(delay_corr) ...
        'winlen' num2str(1000*winlen) 'Low' num2str(locut) 'High' ...
        num2str(highcut) 'order' num2str(orde)];
end
if epochingParams.use_grad == 0
    epoch_dir = [epoch_dir 'magn'];
else
    epoch_dir = [epoch_dir 'grad'];    
end

epoch_dir = [epoch_dir '/'];

