function [rankModel,spectralModel,temporalModel,timeresolvedModel,...
    channelwiseTimeresolvedModel,sparseDA,connectivityModel] = return_style_type(style)

if ( strcmp(style,'threewayDA') | strcmp(style,'temporalthreewayDA') ...
        | strcmp(style,'temporalbilinear') | strcmp(style,'bilinear') ...
        | strcmp(style,'temporalthreewaySDA') | strcmp(style,'temporalthreewayRDA') ...
        | strcmp(style,'temporalthreewayDAfull') | strcmp(style,'temporalthreewayDAfullorig') )
    rankModel = 1;
else
    rankModel = 0;
end

if ( strcmp(style,'temporal') | ... 
        strcmp(style,'spatial') | ...
        strcmp(style,'temporalthreewaySDA') | ...
        strcmp(style,'temporalthreewayDA') | ...
        strcmp(style,'spatiotemporal') | ...
        strcmp(style,'temporalLDA') | ...
        strcmp(style,'temporalbilinear') | ...
        strcmp(style,'temporalICA') | ...
        strcmp(style,'temporalPCA') | ...
        strcmp(style,'spatiotemporalLDA') | ...
        strcmp(style,'temporalthreewayDAfull') | ...
        strcmp(style,'temporalthreewayDAfullorig') | ...
        strcmp(style,'temporalthreewayRDA') | ...
        strcmp(style,'temporalRLDA') | ...
        strcmp(style,'temporalLDAfull') | ...
        strcmp(style,'spatiotemporalLDAfull') | ...
        strcmp(style,'spatiotemporalRLDA') | ...
        strcmp(style,'spatialLDA') | ...
        strcmp(style,'spatialRLDA') | ...
        strcmp(style,'spatialLDAfull') )
    temporalModel = 1;
else
    temporalModel = 0;
end

if ( strcmp(style,'spectralLDA') | strcmp(style,'threewayDA') | ...
        strcmp(style,'bilinear') | strcmp(style,'spectralICA') | ...
        strcmp(style,'spectral') | strcmp(style,'logspectral') | ...
        strcmp(style,'logspectralLDA') | strcmp(style,'spectrospatial') )
    spectralModel = 1;
else
    spectralModel = 0;
end

if strcmp(style,'timeresolved')
    timeresolvedModel = 1;
else
    timeresolvedModel = 0;
end

if strcmp(style,'temporalsplit')
    channelwiseTimeresolvedModel = 1;
else
    channelwiseTimeresolvedModel = 0;
end

if strcmp(style,'temporalthreewaySDA')
    sparseDA = 1;
else
    sparseDA = 0;
end

if ( strcmp(style,'psi') | strcmp(style,'tf') |  strcmp(style,'plv') | strcmp(style,'coh') )
    connectivityModel = 1;
else
    connectivityModel = 0;
end
