function [epochs,A] = runPCAorICA(epochs,ica_on,nrIC,style)

A = [];
if strcmp(style,'temporal') % run PCA
    epochsP = permute(epochs,[2 1 3]);
    concatEpochs = reshape(epochsP,size(epochsP,1)*size(epochsP,2),size(epochsP,3))';
    [COEFF,SCORE,latent] = pca(concatEpochs'*1e10);
    prcomp = SCORE(:,1);
    epochs = reshape(prcomp,size(epochs,1),size(epochs,2));
    A = COEFF(:,1);
else
    if ica_on
        if nrIC > 1000
            nrIC = nrIC - 1000;
            disp('Running PCA....')
            epochsP = permute(epochs,[2 1 3]);
            concatEpochs = reshape(epochsP,size(epochsP,1)*size(epochsP,2),size(epochsP,3))';
            [COEFF,SCORE,latent] = pca(concatEpochs'*1e10);
            prcomp = SCORE(:,1:nrIC);
            epochs = reshape(prcomp,size(epochs,1),size(epochs,2),size(prcomp,2));
            A = COEFF(:,1:nrIC);
        else
            epochsP = permute(epochs,[2 1 3]);            
            concatEpochs = reshape(epochsP,size(epochsP,1)*size(epochsP,2),size(epochsP,3))';
            data2 = concatEpochs*1e10;
            disp('Running Fast-ICA....')
            [ica, A, W] = fastica(data2,'lastEig',nrIC,'g','tanh','verbose','off');
            disp('Fast-ICA completed!')
            icaT = ica';
            epochs = reshape(icaT,size(epochs,1),size(epochs,2),size(icaT,2)); % epokit
        end
    end
end
