function [U,S,V,U2,S2,V2,level_sparsity] = sparseSVDestim4(A,c,rankMax)

%if min(c) < 1
%    error(['Parameter c should be within the range 1 and ' num2str(sqrt(size(A,2)))])
%end
%if max(c) > sqrt(size(A,2))
%    error(['Parameter c should be within the range 1 and ' num2str(sqrt(size(A,2)))])
%end

% dense U
% sparse V

%A = rand(400,22);
%Aorig = A;
%A = Aorig;

verbose = 'off';
pen_v = 1;
maxiter = 15;
tol = 1e-1;
tol2 = 1e-1;

[U2,S2,V2] = svd(A,0);
if nargin == 3
    K = rankMax;
else
    K = min(size(A));
end
if isempty(K)
    K = min(size(A));
end

U = zeros(size(A,1),K);
V = zeros(size(A,2),K);
S = zeros(size(A,1),size(A,2));
pen_u = 0;
lambda_vec = [];
if length(c) > 1
   if K ~= length(c)
       error('Wrong lambda-vector length!')
   else
      lambda_vec = c; 
   end
end

for k = 1:K % for multiple factors:
    if ~isempty(lambda_vec)
       c = lambda_vec(k); 
    end
    if strcmp(verbose,'on')
        fprintf(['Factor ' num2str(k) ':'])
    end
    ite = 1;
    nov = inf;
    nou = inf;
    % initialize v using the power method:
    v = find_initial_v(A);
    u = A*v;
    u = u/norm(u);
    vold = v;
    uold = u;
    % do alternating itetations for u_k,v_k until convergene:
    while nov(ite) > tol || nou(ite) > tol
        %        disp(num2str(nov(ite)))
        ite = ite + 1;
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % 1. Estimate u given v withouth regularization:
        if pen_u == 0
            u = A*v;
            u = u/norm(u);
        end
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % 2. Estimate v given u:
        if pen_v == 0
            v = (u'*A)';
            v = v/norm(v);
        else
            v = soft_threshold(u'*A,0);
            v = v/norm(v);
            v_norm1 = norm(v,1);
            if v_norm1 > c
                v = do_binary_search(A,u,c,tol2);
            end
        end
        nov(ite) = norm(v - vold);
        nou(ite) = norm(u - uold);
        uold = u;
        vold = v;
        if ite == maxiter + 1
            % warning('Maximum number of iterations reached, results may be wrong!')
            break
        end
    end
    if strcmp(verbose,'on')
        fprintf([' total number of iterations ' num2str(ite-1) '\n'])
    end
    % update U,V,S and A:
    d = u'*A*v;
    S(k,k) = d;
    A = A - d*u*v';
    U(:,k) = u;
    V(:,k) = v;
end

level_sparsity = sum(V(:) == 0)/numel(V);
if strcmp(verbose,'on')
    disp(['Level of sparsity ' num2str(level_sparsity)])
end

V = [V zeros(size(V,1),size(V,1)-size(V,2))];
if size(U,2) ~= size(S,1)
    S = S(1:size(U,2),:);
end
