function [U_final,V_final,S_final,rec_err_final,spars_lev_final] = sparseSVDestimCV(A,rankMax)

figOn = 0;
verbose = 0;
nrFolds = 5;
nrC = 10;

if nargin == 1
    rankMax = [];
end



num = numel(A);
winstart = 1;
winend = floor((1/nrFolds)*num);
r = winend;
rp = randperm(num);
trainInds = [];testInds = [];
for m = 1:nrFolds
    if m < nrFolds
        testInds{m} = rp(winstart:winend);
        trainInds{m} = [rp(1:winstart-1) rp(winend+1:end)];
    else
        testInds{m} = rp(winstart:end);
        trainInds{m} = [rp(1:winstart-1)];        
    end
    winstart = winstart + r;
    winend = winend + r;
end
va = linspace(1,sqrt(size(A,2)),nrC);
clear ls 
no_train = zeros(length(va),nrFolds);
no_test = zeros(length(va),nrFolds);
for n = 1:nrFolds
    if verbose
        disp(['Fold: ' num2str(n)])
    end
    Ztrain = A;
    Ztest = A;
    Ztrain(testInds{n}) = 0;
    Ztest(trainInds{n}) = 0;
    for m = 1:length(va)
        [U,S,V,U2,S2,V2,ls(m)] = sparseSVDestim4(Ztrain,va(m),rankMax);
%        disp(num2str(va(m)));
        decomp = U*S*V';
        decomp_train = decomp;
        decomp_test = decomp;
        decomp_train(testInds{n}) = 0;
        decomp_test(trainInds{n}) = 0;
        no_train(m,n) = norm(Ztrain - decomp_train);
        no_test(m,n) = norm(Ztest - decomp_test);
    end
end

me_train = mean(no_train,2);
me_test = mean(no_test,2);
[mi,ind] = min(me_test);
c_final = va(ind);
[U_final,S_final,V_final,U2,S2,V2,spars_lev_final] = sparseSVDestim4(A,c_final,rankMax);
rec_err_final = norm(A - U_final*S_final*V_final');

%clear rec_err rec_err2 spars_lev
%for m = 1:length(va)
%    [U,S,V,U2,S2,V2,spars_lev(m)] = sparseSVDestim4(A,va(m),rankMax);
%    rec_err(m) = norm(A - U*S*V');
%    rec_err2(m) = norm(A - U2*S2*V2');
%end

if figOn
    figure
%    subplot(2,1,1);plot(va,me_train,'r-');hold on;plot(va,me_test,'g-');plot(va,rec_err,'b-');grid on;ylabel('error')
    subplot(2,1,1);plot(va,me_train,'r-');hold on;plot(va,me_test,'g-');grid on;ylabel('error')
    plot(va(ind),me_test(ind),'ko','MarkerSize',6);
    legend('train','test','best')
    %legend('train','test','total','best')
    subplot(2,1,2);plot(va,ls);grid on;ylabel('sparsity');hold on;
    plot(va(ind),ls(ind),'ko','MarkerSize',6)
end

siz = [size(A) rankMax];
V_final = V_final(:,1:min(siz));
U_final = U_final(:,1:min(siz));
S_final = diag(S_final)';
